import { Meta } from "@storybook/addon-docs/blocks";

<Meta title="Welcome|Topics" />

# Topics

## Writing Stories for Storybook

Storybook has been configured to support all story types, but it's probably
best to stick with [MDX story format](https://github.com/storybookjs/storybook/tree/next/addons/docs#mdx)
or [Component Story Format (CSF)](https://storybook.js.org/docs/formats/component-story-format/)
as much as possible to keep up to date with Storybook features.

## Testing

This project uses `jest` as the test runner and encourages
[`@testing-library/react`](https://testing-library.com/docs/react-testing-library/intro).
`jest` has also been configured to use the custom matchers defined by the
[`@testing-library/jest-dom`](https://github.com/testing-library/jest-dom)
library.

## Visual Regression Testing

You have many [paid options](https://storybook.js.org/docs/testing/automated-visual-testing/#libraries-and-services-with-storybook-integration)
available to you, but this project's goal isn't to sell anything or to make a
profit. Therefore, the F/OSS visual regression tool,
[Loki](https://loki.js.org/), has been selected.

### Testing Changes

```sh
yarn loki test
```

If there are any errors from the above command, inspect the visual diffs in
`.loki/difference/`.

### Approving Changes

After manually inspecting the changes in `.loki/difference/` and deciding you're
happy with them, you can accept the changes with:

```sh
yarn loki approve
```

### Continuous integration

Fortunately, [loki supports ci environments quite well](https://loki.js.org/continuous-integration.html)
by analyzing static builds instead. In your CI/CD environment, run

```sh
yarn test:loki:ci
```

This will exit with a non-zero code if any tests are
missing baseline images, or if any of the images have changed.

## Linting / Formatting

Like many projects out there, this one leans on [`eslint`](https://eslint.org/)
for linting and [`prettier`](https://prettier.io/) for code formatting.
`eslint` has been configured to utilize the popular
[`airbnb`](https://github.com/airbnb/javascript) configurations.
